import es
import os
import cPickle
import popuplib
import gamethread
import datetime
import random

info = es.AddonInfo() 
info.name     = "Donor Mod" 
info.version  = "Beta6 - Public" 
info.url      = "http://addons.eventscripts.com/addons/view/DonorMod" 
info.basename = "DonorMod" 
info.author   = "DHack" 
es.ServerVar('DonorMod_Ver', info.version, 'Donor Mod Version').makepublic()

donors = {}
benefits = {}
benefitsorder = []
admins = ['STEAM_0:0:12263433']
settings = {}

verts = ['#default[#lightgreenDonorMod#default] #greenCheck Lucky-Gaming.Com for info about buying credits!',
         '#default[#lightgreenDonorMod#default] #greenType !donor to get to the donor menu!',
         '#default[#lightgreenDonorMod#default] #greenGo to Lucky-Gaming.Com to learn about current raffels/contest going on!',
         '#default[#lightgreenDonorMod#default] #greenSupport Lucky-Gaming DONATE today!',
         '#default[#lightgreenDonorMod#default] #greenGet stuff for donating!',
         '#default[#lightgreenDonorMod#default] #greenGo to Lucky-Gaming.Com for info about buying admin!']

def load():
    es.server.queuecmd("es_loadevents declare addons/eventscripts/donormod/donor_events.res")
    get_database()
    es.regclientcmd('!editcredits', 'donormod/edit_credits', 'This give credits to people!')
    es.regsaycmd('!donor', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!donors', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!doners', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!doner', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!bonors', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!bonor', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!boners', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!boner', 'donormod/donorsendmenu', 'This gives a person tracers!')
    es.regsaycmd('!checkcredits', 'donormod/check_credits', 'This tells you how many credits you have!')
    es.regsaycmd('!credits', 'donormod/check_credits', 'This tells you how many credits you have!')
    path = es.getAddonPath('donormod') + '/load_benefits.txt'
    file = open(path)
    for line in file:
        if not line.startswith("'\'"):
            load = line.split(' ')
            es.reload('donormod/benefits/' + load[1])
    donormodmainmenu = popuplib.create('donormodmainmenu')
    donormodmainmenu.addline('~~ Donor Mod ~~')
    donormodmainmenu.addline('--------------------')
    donormodmainmenu.addline(' ')
    donormodmainmenu.addline('->1. Buy Benefits!')
    donormodmainmenu.addline('->2. Benefits Settings!')
    donormodmainmenu.addline('->3. How to donate!')
    donormodmainmenu.addline('->4. Check Credits!')
    donormodmainmenu.addline('->5. Check Benefits status!')
    donormodmainmenu.addline(' ')
    donormodmainmenu.addline('--------------------')
    donormodmainmenu.addline('->0. Cancel')
    donormodmainmenu.menuselect = donormodmainmenu_menuselect

    gamethread.delayed(320, addverts, ())
    gamethread.delayed(.5, createbenefitmenu, ())
    gamethread.delayed(.5, createbenefitsettingsmenu, ())
    es.msg('Donor mod loaded (beta)')

def createbenefitmenu():
    if popuplib.exists("benefitmenu_menupopup"):
        popuplib.delete("benefitmenu_menupopup")
    benefitmenu_menupopup = popuplib.easymenu("benefitmenu_menupopup", '_popup_choice', benefitmenu_menuselect)
    benefitmenu_menupopup.settitle("Donor Benefits")
    benefitsorder.reverse() 
    for benefit in benefitsorder:
        benefitmenu_menupopup.addoption(benefit, benefits[benefit]["menudisplay"] + " - " + str(benefits[benefit]["cost"]) + " Credits")
    benefitmenu_menupopup.menuselect = benefitmenu_menupopupback

def createbenefitsettingsmenu():
    if popuplib.exists("benefitsettingsmenu_menupopup"):
        popuplib.delete("benefitsettingsmenu_menupopup")
    benefitsettingsmenu_menupopup = popuplib.easymenu("benefitsettingsmenu_menupopup", '_popup_choice', benefitsettingsmenu_menuselect)
    benefitsettingsmenu_menupopup.settitle("Benefits settings")   
    for benefit in settings:
        benefitsettingsmenu_menupopup.addoption(benefit, settings[benefit]["display"])
    benefitsettingsmenu_menupopup.menuselect = benefitsettingsmenu_menupopupback


def benefitsettingsmenu_menupopupback(userid, select, menuname):
    if select == 10:
        popuplib.send('donormodmainmenu', userid)

def benefitsettingsmenu_menuselect(userid, choice, menuname):
    steamid = es.getplayersteamid(userid)
    if steamid in donors and choice in donors[steamid]["benefits"]:
        popuplib.send(settings[choice]["menu"], userid)
    else:
        tell(userid, "Donate to paypal@lucky-gaming.com for credits!")
        sendbenefitsettingsmenu(userid)

def unload():
    save_database()

def es_map_start(ev):
    es.server.queuecmd("es_loadevents addons/eventscripts/donormod/donor_events.res")
    save_database()

def get_database():
   a = es.getAddonPath('donormod') + '/database.db'
   if os.path.isfile(a):
      global donors
      pd = open(a)
      donors = cPickle.load(pd)
      pd.close()

def save_database():
    pd = open(es.getAddonPath('donormod') + '/database.db', 'w')
    cPickle.dump(donors, pd)
    pd.close()
    try:
        copypath = str(es.getAddonPath('donormod') + "/backups/" + time.strftime("%m-%d-%y %H %M %p", time.localtime()))
        os.makedirs(copypath)
        shutil.copy(es.getAddonPath('donormod') + '/database.db', copypath)
    except:
        pass

def edit_credits(steamid = None, amount = None):
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in admins:
        if steamid == None:   
            if es.getargc() == 3:
                steamid = es.getargv(1)
                amount = es.getargv(2)
            else:
                es.tell(userid, 'You entered the wrong amout of arguments')
                return
        if not steamid in donors:
            donors[steamid] = {}
            donors[steamid]["benefits"] = {}
            donors[steamid]["credits"] = int(amount)

        else:
            donors[steamid]['credits'] += int(amount)
        es.tell(userid, "%s has %s credits" % (steamid, donors[steamid]['credits']))
    else:
        es.tell(userid, 'You are not a donor admin!')

def registerbenefit(name, cost, menudisplay, times, tell = True):
    name = str(name)
    cost = int(cost)
    menudisplay = str(menudisplay)
    benefitsorder.append(name)
    benefits[name] = {}
    benefits[name]["cost"] = cost
    benefits[name]['boughttell'] = tell
    benefits[name]["menudisplay"] = menudisplay
    benefits[name]["times"] = times

def registersettingsmenu(benefit, menu, display):
    settings[benefit] = {}
    settings[benefit]['display'] = menu
    settings[benefit]['menu'] = display

def addverts():
    es.msg('#multi', '%s'% random.choice(verts))
    gamethread.delayed(320, addverts, ())

def donorsendmenu(userid = None):
    if userid == None:
        userid = es.getcmduserid()
    popuplib.send('donormodmainmenu', userid)

def donormodmainmenu_menuselect(userid, choice, menuname):
    if choice == 1:
        send_benefitmenu(userid)
    if choice == 2:
        popuplib.send('benefitsettingsmenu_menupopup', userid)
    if choice == 3:
        sendsteamidmenu(userid)
    if choice == 4:
        check_credits(userid)
        popuplib.send('donormodmainmenu', userid)
    if choice == 5:
        sendstatusmenu(userid)

def check_credits(userid = None):
    if userid == None:
        userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in donors:
        tell(userid, 'You have %s credits to spend!' % donors[steamid]['credits'])
    else:
        tell(userid, "Donate to paypal@lucky-gaming.com for credits!")


def send_benefitmenu(userid):
    popuplib.send('benefitmenu_menupopup', userid)

def benefitmenu_menupopupback(userid, select, menuname):
    if select == 10:
        popuplib.send('donormodmainmenu', userid)

def benefitmenu_menuselect(userid, choice, menuname):
    steamid = es.getplayersteamid(userid)
    if steamid in donors and donors[steamid]["credits"] >= benefits[choice]["cost"]:
        givebenefit(userid, choice)
    else:
        tell(userid, "Donate to paypal@lucky-gaming.com for credits!")
    send_benefitmenu(userid)

def givebenefit(userid, benefit):
    steamid = es.getplayersteamid(userid)
    donors[steamid]["credits"] -= benefits[benefit]["cost"]
    if not benefit in donors[steamid]["benefits"]:
        donors[steamid]["benefits"][benefit] = 0
    if benefits[benefit]["times"] == "Monthly":
        if donors[steamid]["benefits"][benefit] == 0 or donors[steamid]["benefits"][benefit] - datetime.date.today().toordinal() < -1:
            donors[steamid]["benefits"][benefit] = datetime.date.today().toordinal()+30
        else:
            donors[steamid]["benefits"][benefit] += 30
        tell(userid, "You now have %s untill %s" % (benefit, datetime.date.fromordinal(donors[steamid]["benefits"][benefit])))
    elif donors[steamid]["benefits"][benefit] != 0:
        donors[steamid]["benefits"][benefit] += int(benefits[benefit]["times"])
    else:
        donors[steamid]["benefits"][benefit] = int(benefits[benefit]["times"])
    if not benefits[benefit]["times"] == "Monthly":
        if benefits[benefit]['boughttell'] == True:
            tell(userid, "You just bought %s - %s in stock" % (benefits[benefit]["menudisplay"], donors[steamid]["benefits"][benefit]))
    es.event("initialize", "donor_benefit_bought")
    es.event("setstring", "donor_benefit_bought", "userid", userid)
    es.event("setstring", "donor_benefit_bought", "benefit", benefit)
    es.event("fire", "donor_benefit_bought")

def checkbenefit(userid, benefit, remove = True):
    steamid = es.getplayersteamid(userid)
    if not steamid in donors:
        return False
    if benefit in donors[steamid]["benefits"]:
        if benefits[benefit]["times"] == "Monthly":
            if donors[steamid]["benefits"][benefit] - datetime.date.today().toordinal() > -1:
                return True
            else:
                del donors[steamid]["benefits"][benefit]
                return False
        elif not donors[steamid]["benefits"][benefit] > 0:
           del donors[steamid]["benefits"][benefit]
           return False
    else:
        return False
    if remove == True:
        if benefits[benefit]["times"] != "Monthly":
            donors[steamid]["benefits"][benefit] -= 1
            if donors[steamid]["benefits"][benefit] <= 0:
                del donors[steamid]["benefits"][benefit]
    return True


def sendbenefitsettingsmenu(userid):
    popuplib.send("benefitsettingsmenu_menupopup", userid)

def sendsteamidmenu(userid):
    #Makes mainmenu and sends to player
    steamid = es.getplayersteamid(userid)
    menu = str(userid) + 'steamidmenu'
    if popuplib.exists(menu):
        popuplib.delete(menu)
    steamidmenu = popuplib.create(menu)
    steamidmenu.addline('~~ Donor Mod~~')
    steamidmenu.addline('--------------------')
    steamidmenu.addline(' ')
    steamidmenu.addline('Visit: Lucky-Gaming.com')
    steamidmenu.addline('         and click donate')
    steamidmenu.addline(' ')
    steamidmenu.addline('or')
    steamidmenu.addline(' ')
    steamidmenu.addline('Donate to paypal@lucky-gaming.com')
    steamidmenu.addline('Give your steamid in the purpose.')
    steamidmenu.addline(' ')
    steamidmenu.addline('->1. Print Steamid')
    steamidmenu.addline(' ')
    steamidmenu.addline('%s' % steamid)
    steamidmenu.addline(' ')
    steamidmenu.addline('1$ = 1000 Credits!')
    steamidmenu.addline('--------------------')
    steamidmenu.addline('->8. Back')
    steamidmenu.addline('->0. Cancel')
    steamidmenu.menuselect = steamidmenu_menuselect
    popuplib.send(menu, userid)

def steamidmenu_menuselect(userid, choice, menu):
    steamid = es.getplayersteamid(userid)
    if choice == 1:
        es.tell(userid, "#multi", "#lightgreenYour Steamid Is #green%s" % es.getplayersteamid(userid))
    if popuplib.exists(menu):
        popuplib.delete(menu)
    if choice == 8:
        popuplib.send('donormodmainmenu', userid)
        return
    sendsteamidmenu(userid)

def sendstatusmenu(userid):
    steamid = es.getplayersteamid(userid)
    menu = str(userid) + 'statusmenu'
    if popuplib.exists(menu):
        popuplib.delete(menu)
    statusmenu = popuplib.create(menu)
    statusmenu.addline('~~ Benefits Status~~')
    statusmenu.addline('--------------------')
    statusmenu.addline(' ')
    for benefit in donors[steamid]["benefits"]:
        if not benefits[benefit]["times"] == "Monthly":
            statusmenu.addline('%s - %s left' % (benefit, donors[steamid]["benefits"][benefit]))
    statusmenu.addline(' ')
    statusmenu.addline('===Monthly===')
    statusmenu.addline(' ')
    for benefit in donors[steamid]["benefits"]:
        if benefits[benefit]["times"] == "Monthly":
            statusmenu.addline('%s untill %s' % (benefit, datetime.date.fromordinal(donors[steamid]["benefits"][benefit])))
    statusmenu.addline(' ')
    statusmenu.addline('--------------------')
    statusmenu.addline('->8. Back')
    statusmenu.addline('->0. Cancel')
    statusmenu.menuselect = statusmenu_menuselect
    popuplib.send(menu, userid)

def statusmenu_menuselect(userid, choice, menu):
    if choice == 8:
        popuplib.send('donormodmainmenu', userid)

def tell(userid, msg):
    es.tell(userid, "#multi", "#lightgreen[#defaultD#greenonor #defaultM#greenod#lightgreen] #default%s" % msg)